﻿using System;
using System.Drawing;
using System.Windows.Forms;

namespace DimensionaTextBox
{
    public partial class Form1 : Form
    {
        // Faz com que o TextBox 
        // se ajuste ao seu conteúdo
        private void AutoSizeTextBox(TextBox txt)
        {
            const int margem_x = 0;
            const int margem_y = 2;
            Size tamanho = TextRenderer.MeasureText(txt.Text, txt.Font);
            txt.ClientSize = new Size(tamanho.Width + margem_x,
                tamanho.Height + margem_y);
        }

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Registra o tratamento de evento para TextChanged 
            txtConteudo.TextChanged += txtConteudo_TextChanged;
            //define multiplas linhas sem usar scrollbars
            txtConteudo.Multiline = true;
            txtConteudo.ScrollBars = ScrollBars.None;

            // Faz com que o TxtBox se ajuste ao texto inicial
            AutoSizeTextBox(txtConteudo);
        }

        private void txtConteudo_TextChanged(object sender, EventArgs e)
        {
            //chama o método AutoSizeTextBox
            AutoSizeTextBox(txtConteudo);
        }
    }
}
